#include <iostream>

const int FieldRows = 4;
const int FieldCols = 4;

enum SpotState { Free, X, O };

void printField( SpotState *field )
{
    for (int y=0; y<FieldRows; y++) {
        for (int x=0; x<FieldCols; x++) {
            std::cout << " ";
            switch (field[y*FieldCols+x]) {
            case SpotState::Free:
                std::cout << "[ ]";
                break;
            case SpotState::X:
                std::cout << "[X]";
                break;
            case SpotState::O:
                std::cout << "[O]";
                break;
            }
        }
        std::cout << std::endl;
    }
    std::cout << std::endl;
}

int evaluateField( SpotState *field )
{
    return 0;
}

int main()
{
    SpotState *field = new SpotState[FieldRows*FieldCols];
    bool running = true;
    bool X = true;
    while(running) {
        // Print field
        printField( field );

        // Get player input
        int x = -1;
        int y = -1;
        std::cout << "Player " << (X ? 1 : 2) << "'s turn" << std::endl;
        std::cout << "Input field coordinate x: ";
        std::cin >> x;
        std::cout << "Input field coordinate y: ";
        std::cin >> y;
        --x;
        --y;

        // Check ranges
        if ((x<0 || FieldCols<=x) || (y<0 || FieldRows<=y)) {
            std::cout << "Coordinates outside of valid range!" << std::endl;
            continue;
        }

        // Check if spot is unset
        if (field[y*FieldCols+x] != SpotState::Free) {
            std::cout << "Selected spot is occupied!" << std::endl;
            continue;
        }

        // Mark spot
        field[y*FieldCols+x] = X ? SpotState::X : SpotState::O;

        // Check for winner
        if (int winner = evaluateField(field) > 0) {
            std::cout << "Player " << winner << " won!" << std::endl;
            break;
        }
        X = !X;
    }
    delete[] field;
    return 0;
}
